package gregapi.random;

import net.minecraft.block.Block;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.world.World;
import net.minecraft.world.biome.BiomeGenBase;

/**
 * @author Gregorius Techneticies
 * 
 * Contains simple Utility Functions based just on the World of the Implementor.
 */
public interface IHasWorld {
	public World getWorld();
	
	public boolean isServerSide();
    public boolean isClientSide();
    
    public int getRandomNumber(int aRange);
    
	public TileEntity getTileEntity(int aX, int aY, int aZ);
	
    public Block getBlock(int aX, int aY, int aZ);
    
	public byte getMetaData(int aX, int aY, int aZ);
	
	public byte getLightLevel(int aX, int aY, int aZ);
	
	public boolean getOpacity(int aX, int aY, int aZ);
	
	public boolean getSky(int aX, int aY, int aZ);
	
	public boolean getAir(int aX, int aY, int aZ);
	
    public BiomeGenBase getBiome(int aX, int aZ);
}