package gregapi.tileentity;

import gregapi.code.TagData;
import gregapi.data.TD;
import gregapi.util.UT;
import ic2.api.energy.tile.IEnergySink;
import net.minecraft.tileentity.TileEntity;
import net.minecraftforge.common.util.ForgeDirection;
import cofh.api.energy.IEnergyReceiver;

/**
 * @author Gregorius Techneticies
 * 
 * For Internal Use.
 */
public class EnergyCompat {
	private static boolean RF_ENERGY = false, IC_ENERGY = false, CHECK_ALL = true;
	
	private static void checkAvailabilities() {
		if (CHECK_ALL) {
			try {
				IEnergyReceiver.class.getCanonicalName();
				RF_ENERGY = true;
			} catch(Throwable e) {/**/}
			try {
				IEnergySink.class.getCanonicalName();
				IC_ENERGY = true;
			} catch(Throwable e) {/**/}
			CHECK_ALL = false;
		}
	}
	
	public static long insertEnergyInto(TagData aEnergyType, byte aSideInto, long aSize, long aAmount, Object aEmitter, TileEntity aReceiver) {
		long rUsedAmount = 0;
		checkAvailabilities();
		if (IC_ENERGY && aEnergyType == TD.Energy.EU && aReceiver instanceof IEnergySink) {
    		if (((IEnergySink)aReceiver).acceptsEnergyFrom(aEmitter instanceof TileEntity ? (TileEntity)aEmitter : null, ForgeDirection.getOrientation(aSideInto))) {
    			while (aAmount > rUsedAmount && ((IEnergySink)aReceiver).getDemandedEnergy() > 0 && ((IEnergySink)aReceiver).injectEnergy(ForgeDirection.getOrientation(aSideInto), aSize, aSize) < aSize) rUsedAmount++;
    		}
		} else if (RF_ENERGY) {
			if (aEnergyType == TD.Energy.RF && aReceiver instanceof IEnergyReceiver && ((IEnergyReceiver)aReceiver).canConnectEnergy(ForgeDirection.getOrientation(aSideInto))) {
				long tRF = UT.Code.bind(0, Integer.MAX_VALUE, aAmount), tUsedAmount = ((IEnergyReceiver)aReceiver).receiveEnergy(ForgeDirection.getOrientation(aSideInto), (int)tRF, false);
				if (tUsedAmount > 0) rUsedAmount += tUsedAmount;
			}
			// GT KineticUnits auto-convert to RF, but only in the Push Phase!
			if (aEnergyType == TD.Energy.KU && aSize > 0 && aReceiver instanceof IEnergyReceiver && ((IEnergyReceiver)aReceiver).canConnectEnergy(ForgeDirection.getOrientation(aSideInto))) {
				long tRF = UT.Code.bind(0, Integer.MAX_VALUE, aAmount * 4), tUsedAmount = ((IEnergyReceiver)aReceiver).receiveEnergy(ForgeDirection.getOrientation(aSideInto), (int)tRF, false);
				if (tUsedAmount > 0) rUsedAmount += UT.Code.units(tUsedAmount, 4, 1, true);
			}
			// MJ auto-convert to RF too. And yes I do know that BuildCraft and other Mods moved from MJ to RF.
			if (aEnergyType == TD.Energy.MJ && aReceiver instanceof IEnergyReceiver && ((IEnergyReceiver)aReceiver).canConnectEnergy(ForgeDirection.getOrientation(aSideInto))) {
				long tRF = UT.Code.bind(0, Integer.MAX_VALUE, aAmount * 10), tUsedAmount = ((IEnergyReceiver)aReceiver).receiveEnergy(ForgeDirection.getOrientation(aSideInto), (int)tRF, false);
				if (tUsedAmount > 0) rUsedAmount += UT.Code.units(tUsedAmount, 10, 1, true);
			}
		}
		return rUsedAmount;
	}
}